`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    08:46:48 03/12/2016 
// Design Name: 
// Module Name:    freqdiv24 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module freqdiv24(
   clk_out, // divided clock output
	clk, // global clock input
	rst_n // active low reset
);

	output clk_out; // divided output
	input clk; // global clock input
	input rst_n; // active low reset
	reg clk_out; // clk output (in always block)
	reg [22:0] cnt;// remainder of the counter
	reg [23:0] cnt_tmp; // input to dff (in always block)
	
	// Combinational logics: increment, neglecting overflow 
	always @*
		cnt_tmp = {clk_out,cnt} + 1'b1;
	
	// Sequential logics: Flip flops
	always @(posedge clk or negedge rst_n)
		if (~rst_n) {clk_out, cnt}<=24'd0;
		else {clk_out,cnt}<=cnt_tmp;


endmodule
